#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

char line[100005];

int main(void)
{
    while (scanf("%s", line) == 1 && strcmp(line, "END") != 0) {
        int len = strlen(line);
        if (line[0] == '-') {
            bool answered = false;
            for (int i = len-1; i >= 1; i--) {
                if (line[i] != '9') {
                    line[i]++;
                    printf("%s\n", line);
                    answered = true;
                    break;
                }
            }
            if (!answered) {
                printf("-1%s\n", line+1);
            }
            continue;
        }
        int sum = 0, suflen = 0;
        for (int i = len-1; i >= 0; i--) {
            int digit = line[i] - '0';
            sum += digit;
            suflen++;
            if (sum + 2 <= suflen * 9 && (i > 0 && line[i-1] != '0')) {
                break;
            }
        }
        //printf("sum=%d,suflen=%d\n", sum, suflen);
        if (suflen < len) {
            for (int i = len-suflen-1; i >= 0; i--) {
                if (line[i] != '0') {
                    line[i]--;
                    break;
                }
            }
            int rem = sum+2;
            for (int i = len-suflen; i < len; i++) {
                int digit = min(rem, 9);
                line[i] = digit + '0';
                rem -= digit;
            }
            int beg = 0;
            while (line[beg] == '0') {
                beg++;
            }
            printf("%s\n", line+beg);
        } else {
            int rem = sum+1;
            int p = 0;
            while (rem > 0) {
                int digit = min(rem, 9);
                line[p++] = digit + '0';
                rem -= digit;
            }
            reverse(line, line+p);
            line[p] = 0;
            printf("-%s\n", line);
        }
    }
}
